/* $Id: COMDXF.h 1.2 1996/07/30 01:07:42 Damien Exp $ */

// Copyright  1990-1995 Ray Dream, Inc. All rights reserved.

#ifndef __COMDXF__
#define __COMDXF__

struct IShFileStream;
struct I3DShScene;
struct I3DShTreeElement;
struct I3DShObject;

#ifndef __I3DEXIO__
#include "I3DExIO.h"
#endif


DEFINE_GUID(CLSID_DxfOut, 0x5C9601ABL, 0x7CC3, 0x101C, 0x88, 0x5F, 0x04, 0x02, 0x1C, 0x00, 0x70, 0x02);

#undef INTERFACE
#define INTERFACE TDXFExporter
class TDXFExporter : public I3DExExportFilter {
public:
	TDXFExporter();
 	~TDXFExporter();

  // IUnknown Interface :
  STDMETHODIMP         QueryInterface(THIS_ REFIID riid, LPVOID* ppvObj);
  STDMETHODIMP_(ULONG) AddRef(THIS);
  STDMETHODIMP_(ULONG) Release(THIS);
  
  // I3DExtension method :
  STDMETHODIMP_(I3DExtension*) Clone(THIS);
  STDMETHODIMP                 ShellUtilitiesInit(THIS_ IShUtilities* shellUtilities);  
  
  // I3DExDataExchanger methods :
  STDMETHODIMP_(ExtensionDataMap*) GetExtensionDataMap(THIS);
  STDMETHODIMP_(void*)             GetExtensionDataBuffer(THIS);
  STDMETHODIMP                     ExtensionDataChanged(THIS);
  STDMETHODIMP                     HandleEvent(THIS_ ULONG sourceID);
  STDMETHODIMP_(short)             GetResID(THIS);
  
  // I3DExExportFilter methods
	STDMETHODIMP_(BOOLEAN) Prepare(THIS_ I3DShScene* scene, I3DShTreeElement* fatherTree);
	STDMETHODIMP_(BOOLEAN) WantsOptionDialog(THIS);
	STDMETHODIMP NeededDiskSpace(THIS_ char* fullPathName, I3DShScene* scene, I3DShTreeElement* fatherTree, ULONG* diskSpace);
	STDMETHODIMP DoExport(THIS_ char* fullPathName, I3DShScene* scene, I3DShTreeElement* fatherTree);
	//-- Preview calls
	STDMETHODIMP_(BOOLEAN) WantsPreview(THIS);
	STDMETHODIMP GetPreviewSize(THIS_ short* sizeh, short* sizev);
	STDMETHODIMP SetPreview(THIS_ IShRasterOffscreen* preview);
private :
  ULONG     	fCRef;  		    // reference Counter
	};


#endif
